"use strict";
/**
 * V0.0.6
 * Changing This Index
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiService = exports.ch = void 0;
const express_1 = __importDefault(require("express"));
const chalk_1 = __importDefault(require("chalk"));
const fs = __importStar(require("fs"));
const dotenv_1 = __importDefault(require("dotenv"));
const bodyparser_1 = require("../configuration/bodyparser");
const cookie_1 = __importDefault(require("../configuration/cookie"));
const session_1 = __importDefault(require("../configuration/session"));
const view_1 = __importDefault(require("../configuration/view"));
const apiService_1 = __importDefault(require("../utils/apiService"));
const mongo_1 = __importDefault(require("../configuration/mongo"));
class App {
    constructor(port, host, cookieSecret, sessionConfig, viewConfig, mongoConfig) {
        this._app = express_1.default();
        this._app.set("port", port || 3000);
        this._app.set("host", host || "localhost");
        this.envConfig();
        bodyparser_1.bodyparser(this._app);
        if (cookieSecret)
            cookie_1.default(this._app, cookieSecret);
        if (sessionConfig)
            session_1.default(this._app, sessionConfig);
        if (viewConfig)
            view_1.default(this._app, viewConfig);
        if (mongoConfig)
            new mongo_1.default(this);
    }
    listen(port, callback) {
        this._app.listen(this.get("port") || port, callback);
        console.log(`
        -------- ${chalk_1.default.blue("Server STARTED ON : ")} => ${this.get("host")}:${this.get("port")} --------------------`);
    }
    route(path, method, ...middlewareAndControllers) {
        this._app[method](path, middlewareAndControllers);
    }
    get(key) {
        return this._app.get(key);
    }
    set(key, value) {
        return this._app.set(key, value);
    }
    getEnv(key) {
        return process.env[key];
    }
    envConfig() {
        if (fs.existsSync(".env")) {
            console.log(chalk_1.default.green(".ENV File Found Success"));
            return dotenv_1.default.config({ path: ".env" });
        }
        else if (fs.existsSync('.env.example')) {
            console.log(chalk_1.default.yellow(".ENV File is Under EXAMPLE Mode , Everything is OK But Change it in FUTURE"));
            return dotenv_1.default.config({ path: ".env.example" });
        }
    }
}
exports.default = App;
exports.ch = chalk_1.default;
exports.ApiService = apiService_1.default;
//# sourceMappingURL=app.js.map