"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequiredConfig = exports.RequiredAdaptor = exports.PassportError = exports.InternalServerError = void 0;
class ClientError {
    /**
     * @param status : status code
     * @param name : error type
     * @param message : message received from server
     * @param details : detail on error
     */
    constructor(status, name, details, message) {
        this.status = 400;
        this.name = "";
        this.details = undefined;
        this.status = status;
        this.name = name;
        this.message = message;
        if (!!details) {
            this.details = details;
        }
        else {
            this.details = undefined;
        }
        console.error({ error: this });
    }
}
exports.default = ClientError;
class InternalServerError extends ClientError {
    constructor(name, message, details) {
        super(500, name, details, message);
    }
}
exports.InternalServerError = InternalServerError;
class PassportError extends ClientError {
    constructor(error, statusCode = 401, name = "unAuthorized") {
        super(error.status || statusCode, error.name || name, error.details, error.message);
    }
}
exports.PassportError = PassportError;
class RequiredAdaptor extends InternalServerError {
    constructor(adaptor) {
        super(`${adaptor}_IS_REQUIRED`, `You must add ${adaptor} as required adaptor in your 'APP' constructor`);
    }
}
exports.RequiredAdaptor = RequiredAdaptor;
class RequiredConfig extends InternalServerError {
    constructor(adaptor) {
        super(`CONFIG_FOR_${adaptor}_IS_REQUIRED`, `You must define ${adaptor} definition in your 'APP' constructor as a 'ConfigurableAdaptor'.
       You must Also set proper config in it.`);
    }
}
exports.RequiredConfig = RequiredConfig;
//# sourceMappingURL=error.js.map