import { Request_Methods } from "../types/interfaces";
export default class ApiService {
    protected uri: string;
    protected headers?: any;
    /**
     * @param uri : REQUIRED example : https://macore.ir/api
     * @param headers : OPTIONAL example : {allow-origin : true}
     */
    constructor(uri: string, headers?: any);
    /**
     * @param url : REQUIRED example : user/:id
     * @param method REQUIRED Request_Methods.TYPE
     * @param body OPTIONAL
     * @param header OPTIONAL
     */
    callService<Request = any, Response = any>(url: string, method: Request_Methods, body?: Request | any, header?: any): Promise<any>;
}
